<?php

namespace EFALIA\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for signatorySendOneSmsResponse StructType
 * @subpackage Structs
 */
class SignatorySendOneSmsResponse extends AbstractStructBase
{
    /**
     * The success
     * @var bool
     */
    public $success;
    /**
     * The signatories
     * @var \EFALIA\StructType\Signatories
     */
    public $signatories;
    /**
     * Constructor method for signatorySendOneSmsResponse
     * @uses SignatorySendOneSmsResponse::setSuccess()
     * @uses SignatorySendOneSmsResponse::setSignatories()
     * @param bool $success
     * @param \EFALIA\StructType\Signatories $signatories
     */
    public function __construct($success = null, \EFALIA\StructType\Signatories $signatories = null)
    {
        $this
            ->setSuccess($success)
            ->setSignatories($signatories);
    }
    /**
     * Get success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->success;
    }
    /**
     * Set success value
     * @param bool $success
     * @return \EFALIA\StructType\SignatorySendOneSmsResponse
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->success = $success;
        return $this;
    }
    /**
     * Get signatories value
     * @return \EFALIA\StructType\Signatories|null
     */
    public function getSignatories()
    {
        return $this->signatories;
    }
    /**
     * Set signatories value
     * @param \EFALIA\StructType\Signatories $signatories
     * @return \EFALIA\StructType\SignatorySendOneSmsResponse
     */
    public function setSignatories(\EFALIA\StructType\Signatories $signatories = null)
    {
        $this->signatories = $signatories;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \EFALIA\StructType\SignatorySendOneSmsResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
